#include "bits/stdc++.h"
using namespace std;

const int N = 250 * 1000 + 10;
vector<int> obejrzane_filmy[N];
unordered_map<int, vector<int>> konczy_ogladac;

int main() {
  ios::sync_with_stdio(0);

  int n;
  cin >> n;

  /// filmy[start] zawiera wszystkie filmy zaczynajace się w minucie `start`.
  /// Film reprezentujemy jako pare liczb: numer filmu i moment zakończenia.
  unordered_map<int, vector<pair<int, int>>> filmy;
  /// Poczatek lub koniec filmu
  set<int> wydarzenia;

  for (int numer_filmu = 1; numer_filmu <= n; numer_filmu++) {
    int start, end;
    cin >> start >> end;

    filmy[start].push_back({numer_filmu, end});
    wydarzenia.insert(start);
    wydarzenia.insert(end);
  }

  int liczba_czlonkow = 0;

  vector<int> dostepni_czlonkowie;

  for (auto czas : wydarzenia) {
    for (auto czlonek : konczy_ogladac[czas]) {
      dostepni_czlonkowie.push_back(czlonek);
    }

    for (auto film : filmy[czas]) {
      int czlonek = -1;
      if (dostepni_czlonkowie.size()) {
        czlonek = dostepni_czlonkowie.back();
        dostepni_czlonkowie.pop_back();
      } else {
        liczba_czlonkow++;
        czlonek = liczba_czlonkow;
      }

      assert(czlonek > 0);

      int numer_filmu = film.first;
      int koniec = film.second;

      obejrzane_filmy[czlonek].push_back(numer_filmu);
      konczy_ogladac[koniec].push_back(czlonek);
    }
  }

  cout << liczba_czlonkow << "\n";

  for (int czlonek = 1; czlonek <= liczba_czlonkow; czlonek++) {
    int obejrzano = obejrzane_filmy[czlonek].size();
    assert(obejrzano > 0);

    cout << obejrzano << " ";
    for (int film : obejrzane_filmy[czlonek]) cout << film << " ";

    cout << "\n";
  }

  return 0;
}
